function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

import { EventEmitter } from 'eventemitter3';

var _abort = /*#__PURE__*/new WeakMap();

export class GrpcCall {
  constructor(method, requestHeaders, headers, responses, trailers, abort, onSendMessage, onFinishSendMessage) {
    _defineProperty(this, "method", void 0);

    _defineProperty(this, "requestHeaders", void 0);

    _defineProperty(this, "headers", void 0);

    _defineProperty(this, "responses", void 0);

    _defineProperty(this, "trailers", void 0);

    _defineProperty(this, "onSendMessage", void 0);

    _defineProperty(this, "onFinishSendMessage", void 0);

    _classPrivateFieldInitSpec(this, _abort, {
      writable: true,
      value: void 0
    });

    _defineProperty(this, "isFinished", false);

    this.method = method;
    this.requestHeaders = requestHeaders;
    this.headers = headers;
    this.responses = responses;
    this.trailers = trailers;

    _classPrivateFieldSet(this, _abort, abort);

    this.onSendMessage = onSendMessage;
    this.onFinishSendMessage = onFinishSendMessage;
  }

  then(onfulfilled, onrejected) {
    return this.completedPromise().then(value => onfulfilled ? Promise.resolve(onfulfilled(value)) : value, reason => onrejected ? Promise.resolve(onrejected(reason)) : Promise.reject(reason));
  }

  sendMessage(data) {
    return this.onSendMessage(data);
  }

  finishSendMessage() {
    if (!this.isFinished) {
      this.isFinished = true;
      return this.onFinishSendMessage();
    }
  }

  cancel() {
    _classPrivateFieldGet(this, _abort).abort();
  }

  async completedPromise() {
    const [headers, trailers] = await Promise.all([this.headers, this.trailers]);
    return {
      method: this.method,
      requestHeaders: this.requestHeaders,
      headers,
      trailers,
      status: 0
    };
  }

}

var _emitter = /*#__PURE__*/new WeakMap();

export class ServerOutputStream {
  constructor() {
    _classPrivateFieldInitSpec(this, _emitter, {
      writable: true,
      value: new EventEmitter()
    });
  }

  on(event, callback) {
    _classPrivateFieldGet(this, _emitter).addListener(event, callback);

    return () => {
      _classPrivateFieldGet(this, _emitter).removeListener(event, callback);
    };
  }

  notifyData(data) {
    _classPrivateFieldGet(this, _emitter).emit('data', data);
  }

  notifyComplete() {
    _classPrivateFieldGet(this, _emitter).emit('complete');
  }

  noitfyError(reason) {
    _classPrivateFieldGet(this, _emitter).emit('error', reason);
  }

}
//# sourceMappingURL=GrpcCall.js.map