import type { GrpcConfig, GrpcMetadata, GrpcMethodType } from './types';
import { GrpcCall } from './GrpcCall';
declare type GrpcRequestObject = {
    data: string;
};
declare type GrpcType = {
    startCall(id: number, config: GrpcConfig, path: string, requestHeaders?: GrpcMetadata, methodType?: GrpcMethodType): Promise<number>;
    sendMessage(id: number, obj: GrpcRequestObject): Promise<boolean>;
    cancelGrpcCall: (id: number) => Promise<boolean>;
    finishClientStreaming(id: number): Promise<void>;
};
declare const GrpcBridge: GrpcType;
export declare class GrpcClient {
    constructor();
    destroy(): void;
    startCall(config: GrpcConfig, method: string, requestHeaders?: GrpcMetadata, methodType?: GrpcMethodType): GrpcCall;
}
export declare const GrpcClientImpl: GrpcClient;
export { GrpcBridge };
